""" webfilter/Header.py

    Copyright (C) 2000,2001  Bastian Kleineidam

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
import webfilter,WebCleanerConf
from get_dom import *

orders = [webfilter.FILTER_REQUEST_HEADER,
          webfilter.FILTER_RESPONSE_HEADER]

class Header(webfilter.Filter):
    def __init__(self):
        self.delete = []
        self.add = {}

    def configure(self, dom):
        import re
        nodes = dom.getElementsByTagName('header')
        for node in nodes:
            name = get_node_attr(node, 'name')
            expr = re.compile(name)
            value = node_value(node)
            if not value:
                self.delete.append(expr)
            else:
                self.add[name] = value

    def filter(self, data, **attrs):
        names = data.keys()
        for name in names:
            for expr in self.delete:
                if expr.search(name):
                    del data[name]
        data.update(self.add)
        return data
